unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, UnitComPort, UnitSG4, UnitErrorCode,
  uSG4Converter, uGCodeAnatomizer, upathdll, Buttons;

type
  TCNCThread = class(TThread)
  private
    com_handle : THandle;
    TimeTicks  : DWORD;
    cnc_code : String;
    idx_sg4 : integer;
    current_line_num : DWORD;
    last_buffered_line_num : DWORD;
    cmd_stop : boolean;
    AERR,AFIFO,ASLEEP,ARUN,AINT,AFLAG : Byte;
    AX, AY, AZ, AU : Integer;
    ANUM, AVACT : DWORD;
    procedure get_cnc_code;
    function move_next : boolean;
    function update_params : boolean;
    procedure display_status;
  public
    procedure Execute; override;
  end;

  Tfmmain = class(TForm)
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    ed_comnr: TEdit;
    BtnComport: TButton;
    lbbaud: TLabel;
    UpDown1: TUpDown;
    cb_baud: TComboBox;
    GroupBox1: TGroupBox;
    lb_decel: TLabel;
    btn_gdecel: TButton;
    lb_accel: TLabel;
    btn_gaccel: TButton;
    btn_saccel: TButton;
    ed_accel: TEdit;
    btn_sdecel: TButton;
    ed_decel: TEdit;
    lb_vmin: TLabel;
    btn_gvmin: TButton;
    lb_vmax: TLabel;
    btn_gvmax: TButton;
    btn_svmax: TButton;
    ed_vmax: TEdit;
    btn_svmin: TButton;
    ed_vmin: TEdit;
    cb_fifo: TCheckBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    btn_abs: TButton;
    btn_rel: TButton;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    ed_axis1: TEdit;
    ed_axis2: TEdit;
    Label5: TLabel;
    btn_kreis: TButton;
    cb_cw: TCheckBox;
    Label7: TLabel;
    Label12: TLabel;
    ed_i: TEdit;
    ed_j: TEdit;
    ed_cmdnum: TEdit;
    Label1: TLabel;
    Label13: TLabel;
    cb_plane: TComboBox;
    GroupBox5: TGroupBox;
    btn_reset_intflag: TButton;
    btn_sstop: TButton;
    btn_continue: TButton;
    btn_fiforst: TButton;
    btn_hstop: TButton;
    GroupBox6: TGroupBox;
    btn_getTargPos: TButton;
    btn_status: TButton;
    btn_GetVact: TButton;
    btn_cmdnum: TButton;
    btn_getposition: TButton;
    btn_getacts: TButton;
    lbvact: TLabel;
    lb_cmdnum: TLabel;
    Label8: TLabel;
    lb_tx: TLabel;
    Label9: TLabel;
    lb_ty: TLabel;
    Label10: TLabel;
    lb_tz: TLabel;
    Label11: TLabel;
    lb_tu: TLabel;
    Label14: TLabel;
    lb_ax: TLabel;
    Label16: TLabel;
    lb_ay: TLabel;
    Label18: TLabel;
    lb_az: TLabel;
    Label20: TLabel;
    lb_au: TLabel;
    cb_lx: TCheckBox;
    cb_ly: TCheckBox;
    cb_lz: TCheckBox;
    cb_lu: TCheckBox;
    cb_rx: TCheckBox;
    cb_ry: TCheckBox;
    cb_rz: TCheckBox;
    cb_ru: TCheckBox;
    Label15: TLabel;
    Label17: TLabel;
    lb_runstate: TLabel;
    Label21: TLabel;
    cb_fifoenabled: TCheckBox;
    cb_error: TCheckBox;
    cb_flx: TCheckBox;
    cb_frx: TCheckBox;
    cb_fly: TCheckBox;
    cb_flz: TCheckBox;
    cb_frz: TCheckBox;
    cb_fru: TCheckBox;
    cb_flu: TCheckBox;
    cb_fry: TCheckBox;
    btn_delay: TButton;
    ed_sleep: TEdit;
    Label6: TLabel;
    Label19: TLabel;
    cb_delay: TCheckBox;
    TabSheet3: TTabSheet;
    Panel3: TPanel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Button4: TButton;
    ed_factor: TEdit;
    ed_rvmax: TEdit;
    ed_rvmin: TEdit;
    ed_raccel: TEdit;
    ed_rdecel: TEdit;
    Panel5: TPanel;
    od_gcode: TOpenDialog;
    btn_run: TButton;
    ed_x: TEdit;
    Label32: TLabel;
    ed_y: TEdit;
    Label33: TLabel;
    ed_u: TEdit;
    Label34: TLabel;
    ed_z: TEdit;
    Label35: TLabel;
    ed_num: TEdit;
    Label2: TLabel;
    btn_act: TButton;
    btn_set_raccuracy: TButton;
    ed_raccuracy: TEdit;
    btn_get_raccuracy: TButton;
    lb_raccuracy: TLabel;
    GroupBox7: TGroupBox;
    btn_version: TButton;
    lb_version: TLabel;
    Label37: TLabel;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    lb_gcode: TListBox;
    lb_sg4code: TListBox;
    btn_showpath: TButton;
    btn_hidepath: TButton;
    Panel6: TPanel;
    Label27: TLabel;
    lb_cax: TLabel;
    lb_cay: TLabel;
    Label_17: TLabel;
    lb_caz: TLabel;
    Label31: TLabel;
    lb_cav: TLabel;
    Label38: TLabel;
    Label28: TLabel;
    lb_cnum: TLabel;
    Label30: TLabel;
    lb_cbufnum: TLabel;
    lb_numdiff: TLabel;
    Label36: TLabel;
    Panel4: TPanel;
    btn_file: TButton;
    Panel7: TPanel;
    btn_xplus: TBitBtn;
    btn_yplus: TBitBtn;
    btn_zplus: TBitBtn;
    btn_xminus: TBitBtn;
    btn_yminus: TBitBtn;
    btn_zminus: TBitBtn;
    cb_step: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure BtnComportClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_getpositionClick(Sender: TObject);
    procedure btn_getTargPosClick(Sender: TObject);
    procedure btn_GetVactClick(Sender: TObject);
    procedure btn_statusClick(Sender: TObject);
    procedure btn_hstopClick(Sender: TObject);
    procedure btn_sstopClick(Sender: TObject);
    procedure btn_fiforstClick(Sender: TObject);
    procedure btn_continueClick(Sender: TObject);
    procedure btn_relClick(Sender: TObject);
    procedure btn_absClick(Sender: TObject);
    procedure btn_kreisClick(Sender: TObject);
    procedure btn_svmaxClick(Sender: TObject);
    procedure btn_svminClick(Sender: TObject);
    procedure btn_saccelClick(Sender: TObject);
    procedure btn_sdecelClick(Sender: TObject);
    procedure btn_gvmaxClick(Sender: TObject);
    procedure btn_gvminClick(Sender: TObject);
    procedure btn_gaccelClick(Sender: TObject);
    procedure btn_gdecelClick(Sender: TObject);
    procedure btn_actClick(Sender: TObject);
    procedure btn_cmdnumClick(Sender: TObject);
    procedure btn_reset_intflagClick(Sender: TObject);
    procedure btn_getactsClick(Sender: TObject);
    procedure btn_delayClick(Sender: TObject);
    procedure btn_fileClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure btn_runClick(Sender: TObject);
    procedure btn_set_raccuracyClick(Sender: TObject);
    procedure btn_get_raccuracyClick(Sender: TObject);
    procedure btn_versionClick(Sender: TObject);
    procedure btn_showpathClick(Sender: TObject);
    procedure btn_hidepathClick(Sender: TObject);
  private
    { Private declarations }
    procedure CNCThreadEnde(Sender: TObject);
  public
    { Public declarations }
    procedure setstatus(stxt : String);
    function get_runstate(AState : Byte) : String;
    procedure display_status(AStatus : DWORD); overload;
    procedure display_status(AERR, AFIFO, ADELAY, ARUN, ASW, AFLAG : Byte); overload;

    function get_linear_pos : String;
    function mSecToTime(AmSec : DWORD) : String;
    procedure SetProgress(fvalue : Single);
    procedure SetElapsedTime(dwmSec : DWORD);
  end;

var
  fmmain : Tfmmain;
  hcomm : THandle;
  CNCThread : TCNCThread;

  gcode_line : TGCodeLine;
  gcodeSG4 : TGCodeConverter;
  liste : TStringList;

implementation

{$R *.DFM}

{ TForm1 }

procedure Tfmmain.setstatus(stxt: String);
begin
  StatusBar1.Panels[0].Text := stxt;
end;

procedure Tfmmain.FormCreate(Sender: TObject);
begin
  hcomm := INVALID_HANDLE_VALUE;
  cb_plane.ItemIndex := 0;
  cb_baud.ItemIndex := 9;
  cb_step.ItemIndex := 0;

  gcode_line := TGCodeLine.Create;
  gcodeSG4 := TGCodeConverter.Create;
  liste := TStringList.Create;
end;

procedure Tfmmain.BtnComportClick(Sender: TObject);
var comnr : Integer;
    dwbaud : DWORD;
    dwerr : DWORD;
begin
  comnr := StrToIntDef(ed_comnr.Text,1);
  dwbaud := StrToIntDef(cb_baud.Items[cb_baud.Itemindex],115200);
  if ComPortConnected(hcomm) then
  begin
    setstatus('Close ComPort:..'+ cx_GetErrorString(CloseComPort(hcomm)));
  end else
  begin
    setstatus('Open ComPort:..'+ cx_GetErrorString(OpenComPort(hcomm,comnr)));
  end;

  if ComPortConnected(hcomm) then
  begin
    BtnComport.Caption := 'COM'+IntToStr(comnr);
    dwerr := SetBaud(hcomm,dwbaud);
    if dwerr = RET_OK then lbbaud.caption := IntToStr(dwbaud)
    else begin
      lbbaud.caption := '-----';
      setstatus('Set Baud:..'+ cx_GetErrorString(dwerr));
      BtnComport.Caption := 'COM?';
      CloseComPort(hcomm);
      exit;
    end;

    dwerr := SetTimeOuts(hcomm,3000,3000); //3 seconds timeout for rx and tx
    if dwerr <> RET_OK then
    begin
      setstatus('Set TimeOuts:..'+ cx_GetErrorString(dwerr));
      BtnComport.Caption := 'COM?';
      CloseComPort(hcomm);
      exit;
    end;
  end else BtnComport.Caption := 'COM?';
end;

procedure Tfmmain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseComPort(hcomm);
  gcode_line.Free;
  gcodeSG4.Free;
  liste.Free;
end;

procedure Tfmmain.btn_hstopClick(Sender: TObject);
begin
  setstatus('hardstop:..'+ cx_GetErrorString(cx_hardstop(hcomm)));
end;

procedure Tfmmain.btn_sstopClick(Sender: TObject);
begin
  setstatus('softstop:..'+ cx_GetErrorString(cx_softstop(hcomm)));
end;

procedure Tfmmain.btn_fiforstClick(Sender: TObject);
begin
  setstatus('fifo reset:..'+ cx_GetErrorString(cx_fiforeset(hcomm)));
end;

procedure Tfmmain.btn_continueClick(Sender: TObject);
begin
  setstatus('continue:..'+ cx_GetErrorString(cx_continue(hcomm)));
end;

function Tfmmain.get_linear_pos : String;
begin
  Result := '';
  if ed_num.Text <> '' then Result := Result + 'n'+ed_num.Text+' ';
  if ed_x.Text <> '' then Result := Result + 'x'+ed_x.Text+' ';
  if ed_y.Text <> '' then Result := Result + 'y'+ed_y.Text+' ';
  if ed_z.Text <> '' then Result := Result + 'z'+ed_z.Text+' ';
  if ed_u.Text <> '' then Result := Result + 'u'+ed_u.Text+' ';
end;

procedure Tfmmain.btn_relClick(Sender: TObject);
begin
  setstatus('relative:..'+ cx_GetErrorString(cx_set_position(hcomm,get_linear_pos,true)));
end;

procedure Tfmmain.btn_absClick(Sender: TObject);
begin
  setstatus('absolute:..'+ cx_GetErrorString(cx_set_position(hcomm,get_linear_pos,false)));
end;

procedure Tfmmain.btn_actClick(Sender: TObject);
begin
  setstatus('zero position:..'+ cx_GetErrorString(cx_set_act_position(hcomm,get_linear_pos)));
end;

procedure Tfmmain.btn_kreisClick(Sender: TObject);
var ax1, ax2, i, j : integer;
    cmdnum : DWORD;
begin
  cmdnum := StrToInt(ed_cmdnum.Text);
  ax1 := StrToInt(ed_axis1.Text);
  ax2 := StrToInt(ed_axis2.Text);
  i := StrToInt(ed_i.Text);
  j := StrToInt(ed_j.Text);
  setstatus('circular:..'+
             cx_GetErrorString(cx_set_circle(hcomm,cmdnum,ax1,ax2,i,j,
                               cb_plane.itemindex,cb_cw.checked)));
end;

procedure Tfmmain.btn_svmaxClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_vmax.text);
  setstatus('set vmax:..'+ cx_GetErrorString(cx_set_vmax(hcomm,dwval,cb_fifo.checked)));
end;

procedure Tfmmain.btn_svminClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_vmin.text);
  setstatus('set vmin:..'+ cx_GetErrorString(cx_set_vmin(hcomm,dwval,cb_fifo.checked)));
end;

procedure Tfmmain.btn_saccelClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_accel.text);
  setstatus('set accel:..'+ cx_GetErrorString(cx_set_accel(hcomm,dwval,cb_fifo.checked)));
end;

procedure Tfmmain.btn_sdecelClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_decel.text);
  setstatus('set decel:..'+ cx_GetErrorString(cx_set_decel(hcomm,dwval,cb_fifo.checked)));
end;

procedure Tfmmain.btn_gvmaxClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_vmax(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_vmax.text := IntToStr(dwval);
    lb_vmax.caption := ed_vmax.text;
  end;
  setstatus('get vmax:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_gvminClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_vmin(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_vmin.text := IntToStr(dwval);
    lb_vmin.caption := ed_vmin.text;
  end;
  setstatus('get vmin:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_GetVactClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_vact(hcomm,dwval);
  if dwerr = RET_OK then
    lbvact.caption := IntToStr(dwval);
  setstatus('get vact:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_gaccelClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_accel(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_accel.text := IntToStr(dwval);
    lb_accel.caption := ed_accel.text;
  end;
  setstatus('get accel:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_gdecelClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_decel(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_decel.text := IntToStr(dwval);
    lb_decel.caption := ed_decel.text;
  end;
  setstatus('get decel:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_getpositionClick(Sender: TObject);
var x,y,z,u : integer;
    dwerr : DWORD;
begin
  dwerr := cx_get_actpos(hcomm,x,y,z,u);
  if dwerr = RET_OK then
  begin
    lb_ax.Caption := IntToStr(x);
    lb_ay.Caption := IntToStr(y);
    lb_az.Caption := IntToStr(z);
    lb_au.Caption := IntToStr(u);
  end;
  setstatus('get act. position:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_getTargPosClick(Sender: TObject);
var x,y,z,u : integer;
    dwerr : DWORD;
begin
  dwerr := cx_get_targpos(hcomm,x,y,z,u);

  if dwerr = RET_OK then
  begin
    lb_tx.Caption := IntToStr(x);
    lb_ty.Caption := IntToStr(y);
    lb_tz.Caption := IntToStr(z);
    lb_tu.Caption := IntToStr(u);
  end;
  setstatus('get target position:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_getactsClick(Sender: TObject);
var AX,AY,AZ,AU : integer;
    AERR, AFIFO, ADELAY, ARUN, ASW, AFLAG : Byte;
    ANUM, AVACT : dword;
    dwerr : DWORD;
begin
  dwerr := cx_get_acts(hcomm,AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG,AX,AY,AZ,AU,ANUM,AVACT);
  if dwerr = RET_OK then
  begin
    lb_ax.Caption := IntToStr(AX);
    lb_ay.Caption := IntToStr(AY);
    lb_az.Caption := IntToStr(AZ);
    lb_au.Caption := IntToStr(AU);

    display_status(AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG);
    lb_cmdnum.caption := IntToStr(ANUM);
    lbvact.caption := IntToStr(AVACT);
  end;
  setstatus('get acts:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_statusClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_status(hcomm,dwval);
  if dwerr = RET_OK then
    display_status(dwval);
  setstatus('get status:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_reset_intflagClick(Sender: TObject);
begin
  setstatus('reset esflag:..'+ cx_GetErrorString(cx_reset_intflag(hcomm)));
end;

procedure Tfmmain.btn_cmdnumClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_act_cmdnum(hcomm,dwval);
  if dwerr = RET_OK then
    lb_cmdnum.caption := IntToStr(dwval);
  setstatus('cmd num:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_set_raccuracyClick(Sender: TObject);
var rad_accuracy : byte;
begin
  rad_accuracy := StrToIntDef(ed_raccuracy.text,1);
  setstatus('set radius error:..'+ cx_GetErrorString(cx_set_radius_accuracy(hcomm,rad_accuracy)));
end;

procedure Tfmmain.btn_get_raccuracyClick(Sender: TObject);
var dwerr : DWORD;
    rad_accuracy  : Byte;
begin
  dwerr := cx_get_radius_accuracy(hcomm,rad_accuracy);
  if dwerr = RET_OK then
  begin
    ed_raccuracy.text := IntToStr(rad_accuracy);
    lb_raccuracy.caption := ed_raccuracy.text;
  end;
  setstatus('get radius err:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.btn_versionClick(Sender: TObject);
var AVersion : DWORD;
   dwerr : DWORD;
begin
  dwerr := cx_get_version(hcomm,AVersion);
  if dwerr = RET_OK then
    lb_version.caption := cx_version_to_str(AVersion)
  else lb_version.caption := '00.00';

  setstatus('get version:..'+ cx_GetErrorString(dwerr));
end;

procedure Tfmmain.display_status(AStatus: DWORD);
begin
  cb_rx.Checked := ((AStatus and $01) = $01);
  cb_ry.Checked := ((AStatus and $02) = $02);
  cb_rz.Checked := ((AStatus and $04) = $04);
  cb_ru.Checked := ((AStatus and $08) = $08);

  cb_lx.Checked := ((AStatus and $10) = $10);
  cb_ly.Checked := ((AStatus and $20) = $20);
  cb_lz.Checked := ((AStatus and $40) = $40);
  cb_lu.Checked := ((AStatus and $80) = $80);

  cb_frx.Checked := ((AStatus and $01000000) = $01000000);
  cb_fry.Checked := ((AStatus and $02000000) = $02000000);
  cb_frz.Checked := ((AStatus and $04000000) = $04000000);
  cb_fru.Checked := ((AStatus and $08000000) = $08000000);

  cb_flx.Checked := ((AStatus and $10000000) = $10000000);
  cb_fly.Checked := ((AStatus and $20000000) = $20000000);
  cb_flz.Checked := ((AStatus and $40000000) = $40000000);
  cb_flu.Checked := ((AStatus and $80000000) = $80000000);

  lb_runstate.caption := get_runstate((AStatus and $00000F00) shr 8);

  cb_fifoenabled.checked := ((AStatus and $00001000) = $00001000);
  cb_error.checked := ((AStatus and $00002000) = $00002000);
  cb_delay.checked := ((AStatus and $00004000) = $00004000);
end;

procedure Tfmmain.display_status(AERR, AFIFO, ADELAY, ARUN, ASW, AFLAG: Byte);
begin
  cb_rx.Checked := ((ASW and $01) = $01);
  cb_ry.Checked := ((ASW and $02) = $02);
  cb_rz.Checked := ((ASW and $04) = $04);
  cb_ru.Checked := ((ASW and $08) = $08);

  cb_lx.Checked := ((ASW and $10) = $10);
  cb_ly.Checked := ((ASW and $20) = $20);
  cb_lz.Checked := ((ASW and $40) = $40);
  cb_lu.Checked := ((ASW and $80) = $80);

  cb_frx.Checked := ((AFLAG and $01) = $01);
  cb_fry.Checked := ((AFLAG and $02) = $02);
  cb_frz.Checked := ((AFLAG and $04) = $04);
  cb_fru.Checked := ((AFLAG and $08) = $08);

  cb_flx.Checked := ((AFLAG and $10) = $10);
  cb_fly.Checked := ((AFLAG and $20) = $20);
  cb_flz.Checked := ((AFLAG and $40) = $40);
  cb_flu.Checked := ((AFLAG and $80) = $80);

  lb_runstate.caption := get_runstate(ARUN);

  cb_fifoenabled.checked := ((AFIFO and $01) = $01);
  cb_error.checked := ((AERR and $01) = $01);
  cb_DELAY.checked := ((ADELAY and $01) = $01);
end;

function Tfmmain.get_runstate(AState: Byte): String;
begin
  Result := '';
  case AState of
    ST_STOPPED     : Result := 'STOPPED';
    ST_ACCEL       : Result := 'ACCEL';
    ST_RUN         : Result := 'RUN';
    ST_DECEL       : Result := 'DECEL';
    ST_RUN_TO_STOP : Result := 'RUN_TO_STOP';
    ST_SOFT_STOP   : Result := 'SOFT_STOPPING';
    ST_HARD_STOP   : Result := 'HARD_STOPPING';
    ST_STOPPING    : Result := 'STOPPING';
  end;
end;

procedure Tfmmain.btn_delayClick(Sender: TObject);
var dwtime : dword;
begin
  dwtime := StrToIntDef(ed_sleep.text,100);
  setstatus('delay:..'+ cx_GetErrorString(cx_delay(hcomm,dwtime)));
end;

procedure Tfmmain.btn_fileClick(Sender: TObject);
var i : integer;
    dwerr : DWORD;
    DataAvailable : Boolean;
begin
  lb_gcode.Clear;
  lb_sg4code.Clear;
  liste.Clear;
  if od_gcode.Execute then
  begin
    lb_gcode.Items.LoadFromFile(od_gcode.filename);
    if lb_gcode.Items.Count > 0 then
    begin
      gcodeSG4.UnitsPerStep := StrToFloat(ed_factor.Text);
      gcodeSG4.VminPercentOfVmax := 50;
      gcodeSG4.AccelDecelTime := 250;
      for i := 0 to lb_gcode.Items.Count - 1 do
      begin
        dwerr := gcode_line.anatomize(lb_gcode.Items.Strings[i],DataAvailable);
        if (dwerr = RET_OK) and (DataAvailable = TRUE) then
        begin
          if gcodeSG4.SG4Convert(gcode_line,i,true) = RET_OK then
            liste.AddStrings(gcodeSG4.SG4Cmds)
          else begin
            Showmessage('ERROR: '+cx_GetErrorString(dwerr));
            break;
          end;
        end;
      end;
      lb_sg4code.Items.AddStrings(liste);
    end;
  end;
end;

procedure Tfmmain.Button4Click(Sender: TObject);
begin
  clearpath;
end;

procedure Tfmmain.btn_runClick(Sender: TObject);
begin
  if CNCThread = nil then
  begin
    btn_run.caption := 'STOP';
    clearpath;
    if cx_fiforeset(hcomm) <> RET_OK then exit;
    {if cx_set_act_position(hcomm,'x0y0z0u0') <> RET_OK then exit;
    if cx_set_vmax(hcomm,StrToIntDef(ed_rvmax.text,1000),false) <> RET_OK then exit;
    if cx_set_vmin(hcomm,StrToIntDef(ed_rvmin.text,100),false) <> RET_OK then exit;
    if cx_set_accel(hcomm,StrToIntDef(ed_raccel.text,100),false) <> RET_OK then exit;
    if cx_set_decel(hcomm,StrToIntDef(ed_rdecel.text,100),false) <> RET_OK then exit;}

    CNCThread := TCNCThread.Create(true);
    CNCThread.cmd_stop := false;
    CNCThread.com_handle := hcomm;
    CNCThread.OnTerminate := CNCThreadEnde;
    CNCThread.Resume;
  end else
  begin
    btn_run.caption := 'STOPPING';
    CNCThread.cmd_stop := true;
    if not CNCThread.Terminated then
      CNCThread.Terminate;
  end;
end;

procedure Tfmmain.SetElapsedTime(dwmSec: DWORD);
begin
  StatusBar1.Panels[4].Text := mSecToTime(dwmSec);
end;

procedure Tfmmain.SetProgress(fvalue: Single);
begin
  StatusBar1.Panels[2].Text := Format('%f',[fvalue])+'%';
end;

{ TCNCThread }

procedure TCNCThread.display_status;
var length_unit : string;
begin
  putxyz(AX,AY,AZ);
//  if fmmain.gcodeSG4.
  length_unit := ' mm';
  fmmain.lb_cax.caption := Format('%.3f'+length_unit,[gcodeSG4.StepsToLength(AX,gcodeSG4.UnitsPerStep)]);
  fmmain.lb_cay.caption := Format('%.3f'+length_unit,[gcodeSG4.StepsToLength(AY,gcodeSG4.UnitsPerStep)]);
  fmmain.lb_caz.caption := Format('%.3f'+length_unit,[gcodeSG4.StepsToLength(AZ,gcodeSG4.UnitsPerStep)]);
  fmmain.lb_cav.caption := Format('%f'+length_unit+'/min',[gcodeSG4.StepsPerSecondToVelocity(AVACT,gcodeSG4.UnitsPerStep)]);
  fmmain.lb_cav.caption := fmmain.lb_cav.caption;// +'  ['+IntToStr(AVACT)+' steps/s]';
  fmmain.lb_cnum.caption := IntToStr(ANUM);
  fmmain.lb_gcode.ItemIndex := ANUM;
  fmmain.lb_cbufnum.caption := IntToStr(last_buffered_line_num);
  fmmain.lb_numdiff.caption := IntToStr(last_buffered_line_num - ANUM);
  fmmain.SetProgress(100*current_line_num/(fmmain.lb_gcode.items.count-1));
  fmmain.SetElapsedTime(GetTickCount-TimeTicks);
  fmmain.update;
end;

procedure TCNCThread.Execute;
var internal_stop : boolean;
begin
  idx_sg4 := 0;
  current_line_num := 0;

  cnc_code := '';
  Synchronize(get_cnc_code);
  if (cnc_code = '') or (idx_sg4 = -1) then exit;
  TimeTicks := GetTickCount;
  repeat
    internal_stop := move_next;
    internal_stop := internal_stop or update_params;
  until (cmd_stop) OR (Terminated) OR (internal_stop);

  if cx_get_acts(hcomm,AERR,AFIFO,ASLEEP,ARUN,AINT,AFLAG,
                       AX,AY,AZ,AU,ANUM,AVACT) = RET_OK then
  begin
    Synchronize(display_status);
    if ARUN <> ST_STOPPED then
      cx_hardstop(hcomm);
  end;

end;

procedure TCNCThread.get_cnc_code;
begin
  if fmmain.lb_sg4code.items.count = 0 then
  begin
    idx_sg4 := -1;
    cnc_code := '';
    exit;
  end;

  if idx_sg4 > fmmain.lb_sg4code.items.count -1 then
  begin
    idx_sg4 := -1;
    cnc_code := '';
    exit;
  end;

  fmmain.lb_sg4code.ItemIndex := idx_sg4;
  if fmmain.lb_sg4code.Items.Objects[idx_sg4] <> nil then
    last_buffered_line_num := DWORD(fmmain.lb_sg4code.Items.Objects[idx_sg4]);
  cnc_code := fmmain.lb_sg4code.Items[fmmain.lb_sg4code.ItemIndex];
end;

function TCNCThread.move_next: boolean;
begin
  Result := false;
  if (idx_sg4 >= 0) and (cnc_code <> '') then
  begin
    case cx_move_it(com_handle,cnc_code) of
    RET_OK : begin
               inc(idx_sg4);
               Synchronize(get_cnc_code);
             end;
    ERR_FIFO_FULL :
             begin

             end;
    else     begin
               Result := true;
             end;
    end;
  end;
end;

function TCNCThread.update_params: boolean;
begin
  if cx_get_acts(hcomm,AERR,AFIFO,ASLEEP,ARUN,AINT,AFLAG,
                       AX,AY,AZ,AU,ANUM,AVACT) = RET_OK then
  begin
    current_line_num := ANUM;
    Result := (AERR > 0) or
              (AFIFO = 0) or
              ((ANUM = DWORD(fmmain.lb_gcode.items.count -1)) and (ARUN = ST_STOPPED));
    Synchronize(display_status);
  end else Result := true;
end;

procedure Tfmmain.CNCThreadEnde(Sender: TObject);
begin
  FreeAndNil(CNCThread);
  btn_run.caption := 'RUN';
end;

function Tfmmain.mSecToTime(AmSec: DWORD): String;
var ZH, ZM, ZS, ZmS: DWORD;
begin
  ZH := AmSec div 3600000;
  ZM := (AmSec div 60000) - (ZH * 60);
  ZS := (AmSec DIV 1000) - ((ZH * 3600) + (ZM * 60));
  ZmS := AmSec - ((ZH * 3600000) + (ZM * 60000) + (ZS * 1000));
  Result := Format('%.2d:%.2d:%.2d.%.3d',[ZH,ZM,ZS,ZmS]);
end;

procedure Tfmmain.btn_showpathClick(Sender: TObject);
begin
  showpath;
end;

procedure Tfmmain.btn_hidepathClick(Sender: TObject);
begin
  hidepath;
end;

end.
