unit UnitCmds;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, UnitMain, UnitSG4, UnitErrorCode;

type
  TfmSG4 = class(TForm)
    GroupBox7: TGroupBox;
    lb_version: TLabel;
    btn_version: TButton;
    GroupBox6: TGroupBox;
    lbvact: TLabel;
    lb_cmdnum: TLabel;
    Label8: TLabel;
    lb_tx: TLabel;
    Label9: TLabel;
    lb_ty: TLabel;
    Label10: TLabel;
    lb_tz: TLabel;
    Label11: TLabel;
    lb_tu: TLabel;
    Label14: TLabel;
    lb_ax: TLabel;
    Label16: TLabel;
    lb_ay: TLabel;
    Label18: TLabel;
    lb_az: TLabel;
    Label20: TLabel;
    lb_au: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    lb_runstate: TLabel;
    Label21: TLabel;
    btn_getTargPos: TButton;
    btn_status: TButton;
    btn_GetVact: TButton;
    btn_cmdnum: TButton;
    btn_getacts: TButton;
    cb_lx: TCheckBox;
    cb_ly: TCheckBox;
    cb_lz: TCheckBox;
    cb_lu: TCheckBox;
    cb_rx: TCheckBox;
    cb_ry: TCheckBox;
    cb_rz: TCheckBox;
    cb_ru: TCheckBox;
    cb_fifoenabled: TCheckBox;
    cb_error: TCheckBox;
    cb_flx: TCheckBox;
    cb_frx: TCheckBox;
    cb_fry: TCheckBox;
    cb_fly: TCheckBox;
    cb_flz: TCheckBox;
    cb_frz: TCheckBox;
    cb_fru: TCheckBox;
    cb_flu: TCheckBox;
    btn_getposition: TButton;
    cb_delay: TCheckBox;
    GroupBox5: TGroupBox;
    lb_raccuracy: TLabel;
    btn_fiforst: TButton;
    btn_hstop: TButton;
    btn_sstop: TButton;
    btn_continue: TButton;
    btn_reset_intflag: TButton;
    btn_set_raccuracy: TButton;
    ed_raccuracy: TEdit;
    btn_get_raccuracy: TButton;
    GroupBox1: TGroupBox;
    lb_decel: TLabel;
    lb_accel: TLabel;
    lb_vmin: TLabel;
    lb_vmax: TLabel;
    btn_saccel: TButton;
    ed_accel: TEdit;
    btn_sdecel: TButton;
    ed_decel: TEdit;
    btn_svmax: TButton;
    ed_vmax: TEdit;
    btn_svmin: TButton;
    ed_vmin: TEdit;
    cb_fifo: TCheckBox;
    btn_gvmax: TButton;
    btn_gaccel: TButton;
    btn_gvmin: TButton;
    btn_gdecel: TButton;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label19: TLabel;
    GroupBox3: TGroupBox;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label2: TLabel;
    btn_abs: TButton;
    btn_rel: TButton;
    ed_x: TEdit;
    ed_y: TEdit;
    ed_u: TEdit;
    ed_z: TEdit;
    ed_num: TEdit;
    btn_act: TButton;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label12: TLabel;
    Label1: TLabel;
    Label13: TLabel;
    ed_axis1: TEdit;
    ed_axis2: TEdit;
    btn_kreis: TButton;
    cb_cw: TCheckBox;
    ed_i: TEdit;
    ed_j: TEdit;
    ed_cmdnum: TEdit;
    cb_plane: TComboBox;
    btn_delay: TButton;
    ed_sleep: TEdit;
    StatusBar1: TStatusBar;
    cb_inc_ij: TCheckBox;
    cb_inc_ep: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btn_hstopClick(Sender: TObject);
    procedure btn_sstopClick(Sender: TObject);
    procedure btn_fiforstClick(Sender: TObject);
    procedure btn_continueClick(Sender: TObject);
    procedure btn_relClick(Sender: TObject);
    procedure btn_absClick(Sender: TObject);
    procedure btn_actClick(Sender: TObject);
    procedure btn_kreisClick(Sender: TObject);
    procedure btn_svmaxClick(Sender: TObject);
    procedure btn_svminClick(Sender: TObject);
    procedure btn_saccelClick(Sender: TObject);
    procedure btn_sdecelClick(Sender: TObject);
    procedure btn_gvmaxClick(Sender: TObject);
    procedure btn_gvminClick(Sender: TObject);
    procedure btn_GetVactClick(Sender: TObject);
    procedure btn_gaccelClick(Sender: TObject);
    procedure btn_gdecelClick(Sender: TObject);
    procedure btn_getpositionClick(Sender: TObject);
    procedure btn_getTargPosClick(Sender: TObject);
    procedure btn_getactsClick(Sender: TObject);
    procedure btn_statusClick(Sender: TObject);
    procedure btn_reset_intflagClick(Sender: TObject);
    procedure btn_cmdnumClick(Sender: TObject);
    procedure btn_set_raccuracyClick(Sender: TObject);
    procedure btn_get_raccuracyClick(Sender: TObject);
    procedure btn_versionClick(Sender: TObject);
    procedure btn_delayClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure setstatus(stxt : String);
    function get_linear_pos : String;
    procedure display_status(AStatus : DWORD); overload;
    procedure display_status(AERR, AFIFO, ADELAY, ARUN, ASW, AFLAG : Byte); overload;
    function get_runstate(AState : Byte) : String;
  end;

var
  fmSG4: TfmSG4;

implementation

{$R *.DFM}

procedure TfmSG4.FormCreate(Sender: TObject);
begin
  cb_plane.ItemIndex := 0;
end;

procedure TfmSG4.setstatus(stxt: String);
begin
  StatusBar1.Panels[0].Text := stxt;
end;

procedure TfmSG4.btn_hstopClick(Sender: TObject);
begin
  setstatus('hardstop:..'+ cx_GetErrorString(cx_hardstop(hcomm)));
end;

procedure TfmSG4.btn_sstopClick(Sender: TObject);
begin
  setstatus('softstop:..'+ cx_GetErrorString(cx_softstop(hcomm)));
end;

procedure TfmSG4.btn_fiforstClick(Sender: TObject);
begin
  setstatus('fifo reset:..'+ cx_GetErrorString(cx_fiforeset(hcomm)));
end;

procedure TfmSG4.btn_continueClick(Sender: TObject);
begin
  setstatus('continue:..'+ cx_GetErrorString(cx_continue(hcomm)));
end;

procedure TfmSG4.btn_relClick(Sender: TObject);
begin
  setstatus('relative:..'+ cx_GetErrorString(cx_set_position(hcomm,get_linear_pos,true)));
end;

procedure TfmSG4.btn_absClick(Sender: TObject);
begin
  setstatus('absolute:..'+ cx_GetErrorString(cx_set_position(hcomm,get_linear_pos,false)));
end;

procedure TfmSG4.btn_actClick(Sender: TObject);
begin
  setstatus('zero position:..'+ cx_GetErrorString(cx_set_act_position(hcomm,get_linear_pos)));
end;

procedure TfmSG4.btn_kreisClick(Sender: TObject);
var ax1, ax2, i, j : integer;
    cmdnum : DWORD;
begin
  cmdnum := StrToInt(ed_cmdnum.Text);
  ax1 := StrToInt(ed_axis1.Text);
  ax2 := StrToInt(ed_axis2.Text);
  i := StrToInt(ed_i.Text);
  j := StrToInt(ed_j.Text);
  setstatus('circular:..'+
             cx_GetErrorString(cx_set_circle(hcomm,cmdnum,ax1,ax2,i,j,
                               cb_plane.itemindex,cb_cw.checked,
                               cb_inc_ij.checked,cb_inc_ep.checked)));
end;

procedure TfmSG4.btn_delayClick(Sender: TObject);
var dwtime : dword;
begin
  dwtime := StrToIntDef(ed_sleep.text,100);
  setstatus('delay:..'+ cx_GetErrorString(cx_delay(hcomm,dwtime)));
end;

procedure TfmSG4.btn_svmaxClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_vmax.text);
  setstatus('set vmax:..'+ cx_GetErrorString(cx_set_vmax(hcomm,dwval,cb_fifo.checked)));
end;

procedure TfmSG4.btn_svminClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_vmin.text);
  setstatus('set vmin:..'+ cx_GetErrorString(cx_set_vmin(hcomm,dwval,cb_fifo.checked)));
end;

procedure TfmSG4.btn_saccelClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_accel.text);
  setstatus('set accel:..'+ cx_GetErrorString(cx_set_accel(hcomm,dwval,cb_fifo.checked)));
end;

procedure TfmSG4.btn_sdecelClick(Sender: TObject);
var dwval : dword;
begin
  dwval := StrToInt(ed_decel.text);
  setstatus('set decel:..'+ cx_GetErrorString(cx_set_decel(hcomm,dwval,cb_fifo.checked)));
end;

procedure TfmSG4.btn_gvmaxClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_vmax(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_vmax.text := IntToStr(dwval);
    lb_vmax.caption := ed_vmax.text;
  end;
  setstatus('get vmax:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_gvminClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_vmin(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_vmin.text := IntToStr(dwval);
    lb_vmin.caption := ed_vmin.text;
  end;
  setstatus('get vmin:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_GetVactClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_vact(hcomm,dwval);
  if dwerr = RET_OK then
    lbvact.caption := IntToStr(dwval);
  setstatus('get vact:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_gaccelClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_accel(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_accel.text := IntToStr(dwval);
    lb_accel.caption := ed_accel.text;
  end;
  setstatus('get accel:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_gdecelClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_decel(hcomm,dwval);
  if dwerr = RET_OK then
  begin
    ed_decel.text := IntToStr(dwval);
    lb_decel.caption := ed_decel.text;
  end;
  setstatus('get decel:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_getpositionClick(Sender: TObject);
var x,y,z,u : integer;
    dwerr : DWORD;
begin
  dwerr := cx_get_actpos(hcomm,x,y,z,u);
  if dwerr = RET_OK then
  begin
    lb_ax.Caption := IntToStr(x);
    lb_ay.Caption := IntToStr(y);
    lb_az.Caption := IntToStr(z);
    lb_au.Caption := IntToStr(u);
  end;
  setstatus('get act. position:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_getTargPosClick(Sender: TObject);
var x,y,z,u : integer;
    dwerr : DWORD;
begin
  dwerr := cx_get_targpos(hcomm,x,y,z,u);

  if dwerr = RET_OK then
  begin
    lb_tx.Caption := IntToStr(x);
    lb_ty.Caption := IntToStr(y);
    lb_tz.Caption := IntToStr(z);
    lb_tu.Caption := IntToStr(u);
  end;
  setstatus('get target position:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_getactsClick(Sender: TObject);
var AX,AY,AZ,AU : integer;
    AERR, AFIFO, ADELAY, ARUN, ASW, AFLAG : Byte;
    ANUM, AVACT : dword;
    dwerr : DWORD;
begin
  dwerr := cx_get_acts(hcomm,AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG,AX,AY,AZ,AU,ANUM,AVACT);
  if dwerr = RET_OK then
  begin
    lb_ax.Caption := IntToStr(AX);
    lb_ay.Caption := IntToStr(AY);
    lb_az.Caption := IntToStr(AZ);
    lb_au.Caption := IntToStr(AU);

    display_status(AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG);
    lb_cmdnum.caption := IntToStr(ANUM);
    lbvact.caption := IntToStr(AVACT);
  end;
  setstatus('get acts:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_statusClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_status(hcomm,dwval);
  if dwerr = RET_OK then
    display_status(dwval);
  setstatus('get status:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_reset_intflagClick(Sender: TObject);
begin
  setstatus('reset esflag:..'+ cx_GetErrorString(cx_reset_intflag(hcomm)));
end;

procedure TfmSG4.btn_cmdnumClick(Sender: TObject);
var dwval, dwerr : DWORD;
begin
  dwerr := cx_get_act_cmdnum(hcomm,dwval);
  if dwerr = RET_OK then
    lb_cmdnum.caption := IntToStr(dwval);
  setstatus('cmd num:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_set_raccuracyClick(Sender: TObject);
var rad_accuracy : byte;
begin
  rad_accuracy := StrToIntDef(ed_raccuracy.text,1);
  setstatus('set radius error:..'+ cx_GetErrorString(cx_set_radius_accuracy(hcomm,rad_accuracy)));
end;

procedure TfmSG4.btn_get_raccuracyClick(Sender: TObject);
var dwerr : DWORD;
    rad_accuracy  : Byte;
begin
  dwerr := cx_get_radius_accuracy(hcomm,rad_accuracy);
  if dwerr = RET_OK then
  begin
    ed_raccuracy.text := IntToStr(rad_accuracy);
    lb_raccuracy.caption := ed_raccuracy.text;
  end;
  setstatus('get radius err:..'+ cx_GetErrorString(dwerr));
end;

procedure TfmSG4.btn_versionClick(Sender: TObject);
var AVersion : DWORD;
   dwerr : DWORD;
begin
  dwerr := cx_get_version(hcomm,AVersion);
  if dwerr = RET_OK then
    lb_version.caption := cx_version_to_str(AVersion)
  else lb_version.caption := '00.00';

  setstatus('get version:..'+ cx_GetErrorString(dwerr));
end;

function TfmSG4.get_linear_pos: String;
begin
  Result := '';
  if ed_num.Text <> '' then Result := Result + 'n'+ed_num.Text+' ';
  if ed_x.Text <> '' then Result := Result + 'x'+ed_x.Text+' ';
  if ed_y.Text <> '' then Result := Result + 'y'+ed_y.Text+' ';
  if ed_z.Text <> '' then Result := Result + 'z'+ed_z.Text+' ';
  if ed_u.Text <> '' then Result := Result + 'u'+ed_u.Text+' ';
end;

procedure TfmSG4.display_status(AStatus: DWORD);
begin
  cb_rx.Checked := ((AStatus and $01) = $01);
  cb_ry.Checked := ((AStatus and $02) = $02);
  cb_rz.Checked := ((AStatus and $04) = $04);
  cb_ru.Checked := ((AStatus and $08) = $08);

  cb_lx.Checked := ((AStatus and $10) = $10);
  cb_ly.Checked := ((AStatus and $20) = $20);
  cb_lz.Checked := ((AStatus and $40) = $40);
  cb_lu.Checked := ((AStatus and $80) = $80);

  cb_frx.Checked := ((AStatus and $01000000) = $01000000);
  cb_fry.Checked := ((AStatus and $02000000) = $02000000);
  cb_frz.Checked := ((AStatus and $04000000) = $04000000);
  cb_fru.Checked := ((AStatus and $08000000) = $08000000);

  cb_flx.Checked := ((AStatus and $10000000) = $10000000);
  cb_fly.Checked := ((AStatus and $20000000) = $20000000);
  cb_flz.Checked := ((AStatus and $40000000) = $40000000);
  cb_flu.Checked := ((AStatus and $80000000) = $80000000);

  lb_runstate.caption := get_runstate((AStatus and $00000F00) shr 8);

  cb_fifoenabled.checked := ((AStatus and $00001000) = $00001000);
  cb_error.checked := ((AStatus and $00002000) = $00002000);
  cb_delay.checked := ((AStatus and $00004000) = $00004000);
end;

procedure TfmSG4.display_status(AERR, AFIFO, ADELAY, ARUN, ASW,
  AFLAG: Byte);
begin
  cb_rx.Checked := ((ASW and $01) = $01);
  cb_ry.Checked := ((ASW and $02) = $02);
  cb_rz.Checked := ((ASW and $04) = $04);
  cb_ru.Checked := ((ASW and $08) = $08);

  cb_lx.Checked := ((ASW and $10) = $10);
  cb_ly.Checked := ((ASW and $20) = $20);
  cb_lz.Checked := ((ASW and $40) = $40);
  cb_lu.Checked := ((ASW and $80) = $80);

  cb_frx.Checked := ((AFLAG and $01) = $01);
  cb_fry.Checked := ((AFLAG and $02) = $02);
  cb_frz.Checked := ((AFLAG and $04) = $04);
  cb_fru.Checked := ((AFLAG and $08) = $08);

  cb_flx.Checked := ((AFLAG and $10) = $10);
  cb_fly.Checked := ((AFLAG and $20) = $20);
  cb_flz.Checked := ((AFLAG and $40) = $40);
  cb_flu.Checked := ((AFLAG and $80) = $80);

  lb_runstate.caption := get_runstate(ARUN);

  cb_fifoenabled.checked := ((AFIFO and $01) = $01);
  cb_error.checked := ((AERR and $01) = $01);
  cb_DELAY.checked := ((ADELAY and $01) = $01);
end;

function TfmSG4.get_runstate(AState: Byte): String;
begin
  Result := '';
  case AState of
    ST_STOPPED     : Result := 'STOPPED';
    ST_ACCEL       : Result := 'ACCEL';
    ST_RUN         : Result := 'RUN';
    ST_DECEL       : Result := 'DECEL';
    ST_RUN_TO_STOP : Result := 'RUN_TO_STOP';
    ST_SOFT_STOP   : Result := 'SOFT_STOPPING';
    ST_HARD_STOP   : Result := 'HARD_STOPPING';
    ST_STOPPING    : Result := 'STOPPING';
  end;
end;

end.
